#include "jpg2pcx.h"

void palcreate(unsigned char * palarray)
{ // 4x4x4 Farbwuerfel, auf 0/0/0 max/max/max Ausdehnung
  // Bits werden MSB..LSB: rrggbb
unsigned int r,g,b,n,R,G,B;
#define wrpal(r,g,b,n) palarray[n+n+n]=r; palarray[n+n+n+1]=g; palarray[n+n+n+2]=b
for (r=R=n=0;R<4;R++)
{ for (g=G=0;G<4;G++) 
  { for (b=B=0;B<4;B++)
    { wrpal(r,g,b,n);
      n++;
      b+=85;
    };
    g+=85;
  };
  r+=85;
};
while (n<256) { wrpal(255,255,255,n); n++; };
#undef wrpal
return;
};

int farbreduktion(unsigned char * buf, int xsize, int ysize)
// Assemblervorschlaege ohne Jcc von AMD:
// abs: z=wert sar 31; erg=(wert ^ z) - z
// min: x -= y; sbb z,z /* wird 0 oder -1 */; z &= x; z += y
// TGA: UNTEN ZUERST, BYTEFOLGE B,G,R !!!
{
unsigned int bufsize,linesize;
unsigned int x,y,n;
unsigned /* char */ int r,g,b,R,G,B,i;
signed int ri,gi,bi,ii;
unsigned char * buf2;
#define HISTSIZE (1<<(BITS+BITS+BITS))
int rhist[QQ],ghist[QQ],bhist[QQ],histo[HISTSIZE]; // assume no overflows!

linesize = xsize * 3;
bufsize = linesize * ysize;
r=g=b=255; R=G=B=0;
for (n=0;n<QQ;n++) { rhist[n]=ghist[n]=bhist[n]=0; };
for (n=0;n<HISTSIZE;n++) histo[n]=0;

buf2 = buf;   // Histogramm startet...
for (y=0;y<ysize;y++)
  for (x=0;x<xsize;x++)
  { r=buf2[2]>>QS; g=buf2[1]>>QS; b=buf2[0]>>QS; // BGR
    buf2+=3;
    rhist[r]++; ghist[g]++; bhist[b]++;
    histo[(r<<(BITS+BITS)) + (g<<BITS) + b]++;
  };

buf2 = buf; // Schritt 2...
/* ***** HISTO IRGENDWIE VISUALISIEREN ***** */

buf2 = buf; // Rand oben killen
if (TOPCUT<ysize)
{ buf2 += xsize * 3 * (ysize-TOPCUT); // bei TGA unten am Fileanfang...
  for (y=0; y < TOPCUT ;y++)
    for (x=0;x<xsize;x++)
    { if (buf2[0]>CUTLIM) buf2[0]=255;
      if (buf2[1]>CUTLIM) buf2[1]=255;
      if (buf2[2]>CUTLIM) buf2[2]=255;
      buf2+=3;
    }; // EOF beide for Schleifen
}; // EOF if Bild gross genug

buf2 = buf; // Hauptlogik
i = (1<<BITS) - 1;
for (y=0;y<ysize;y++)
  for (x=0;x<xsize;x++)
  { // billig-Farbreduktion auf 4x4x4 Farbwuerfel, aber
    // Grenzen sind so, dass ab 3/4 von max Ergebnis max ist
    ri = r = buf2[2];
    gi = g = buf2[1];
    bi = b = buf2[0]; // BGR
    if ((b+b)>(r+g+BLULIM)) 
      b = (b<(256-BLUPUSH)) ? (b+BLUPUSH) : 255; // Blau-Betonungs-Trick
    ii = 0;
    i=(ri-gi); i=(i<0)?-i:i; if (i<GREYLIM) { r = g = (r+b)>>1; ii++; };
    i=(gi-bi); i=(i<0)?-i:i; if (i<GREYLIM) { g = b = (g+b)>>1; ii++; };
    i=(bi-ri); i=(i<0)?-i:i; if (i<GREYLIM) { b = r = (b+r)>>1; ii++; };
    if (ii>0)
      { ri = r;  gi = g;  bi = b; // zur Sicherheit 2. Durchlauf...
        i=(ri-gi); i=(i<0)?-i:i; if (i<GREYLIM) { r = g = (r+b)>>1; ii++; };
        i=(gi-bi); i=(i<0)?-i:i; if (i<GREYLIM) { g = b = (g+b)>>1; ii++; };
        i=(bi-ri); i=(i<0)?-i:i; if (i<GREYLIM) { b = r = (b+r)>>1; ii++; };
      };
// #ifdef DEBUG
//    if ( (ii>0) && ((ri!=r) || (gi!=g) || (bi!=b)) )
//      fprintf(stderr,"reduce: farbreduktion() 2. Graulauf zeigt Wirkung\n");
// #endif
    ri = r;  gi = g;  bi = b;
    // jetzt siehts grau aus...
    r = r >> QS;
    g = g >> QS;
    b = b >> QS;
    // quantisiert (ab hier evtl. Lookup verwenden)
    i=0;
    if (r>=(WHITEGREY>>QS)) i++;
    if (g>=(WHITEGREY>>QS)) i++;
    if (b>=(WHITEGREY>>QS)) i++;
    if (i>=2) { buf2[0] = 63; } // das war Weiss
    else
      { if ((r==g) && (g==b))
          { r = (QS<6) ? (r >> (6-QS)) : (r << (QS-6)); // wird also 0..3
            if (r>1) r--; // 0123 -> 0122
            buf2[0] = r | (r<<2) | (r<<4); // Graustufen
          }
        else
          { i=0; // wird 1, falls Entscheidung getroffen wird
            if ((r>g) && (r>b)) 
              { r = (QS<6) ? (r >> (6-QS)) : (r << (QS-6)); // wird 0..3
                buf2[0] = r << 4; i++; 
              } else
            if ((g>r) && (g>b))
              { g = (QS<6) ? (g >> (6-QS)) : (g << (QS-6)); // wird 0..3
                buf2[0] = g << 2; i++; 
              } else
            if ((b>r) && (b>g))
              { b = (QS<6) ? (b >> (6-QS)) : (b << (QS-6)); // wird 0..3
                buf2[0] = b; i++; 
              };
            if (!i)
              { // Immernoch keine Entscheidung, hm...
                // Erfahrung: Dunkel-Lila ist Rot, Hell-Lila aber Blau.
                // Cyans sind eher Grau, Gelbs eher Rot
                i=1; // Default jetzt Rot bei Entscheidungsproblem
                /* if (b<r) { *//* Braun/Gelb -> Rot *//* } else */
                if (g<r) 
                  { /* Lila -> Rot ODER Blau */ 
                    if (b>=(B_M_LIM>>QS)) i=3; /* genug B fuer Blau */
                  } else
                if (r<g) { /* Cyan */ i=2; };
                if (i==1) /* Rot */
                  { r = (QS<6) ? (r >> (6-QS)) : (r << (QS-6)); // wird 0..3
                    buf2[0] = r << 4; i++; 
                  } else
                if (i==2) /* Grau (Gruen) */
                  { g = (QS<6) ? (g >> (6-QS)) : (g << (QS-6)); // wird 0..3
                    buf2[0] = (g << 2) | (g << 4) | g; i++;
                  } else
                  { b = (QS<6) ? (b >> (6-QS)) : (b << (QS-6)); // wird 0..3
                    buf2[0] = b; i++; 
                  };
              }; // EOF Entscheidungen aus Erfahrung
          }; // EOF keine Graustufe
      }; // EOF kein Weiss
    buf2+=3;
  };

buf2 = buf;   // Nochmal hinter Blau her rennen :(
for (y=0;y<(ysize-2);y++)
{ int iii;
  for (iii=ii=x=0;x<(xsize-2);x++)
  { r=3 & (buf2[0]>>4);
    g=3 & (buf2[0]>>2);
    b=3 & buf2[0]; 
    i= ((b>r) && (b>g)) ? 1 : 0; // Blaupixel?
    if ((i & iii)==1) 
      if ( (buf2[-3]==42 /* 0222 */) || ((buf2[-3] & 42)==0) )
        // Grau2 oder R,G,B alle max. 1 ?
#define SETmeBLU 63
        buf2[-3] = (buf2[-3] & (63^SETmeBLU) & 60) | (buf2[0] & (3 | SETmeBLU));
        // Kopiere Alles/Blauanteil, falls vorletztes auch Blaupixel war
#undef SETmeBLU
    buf2+=3;
    iii=ii; ii=i; // History
  };
  buf2+=6; // 2 Randpixel!
};

buf2 = buf;   // Rotlinge und Gruenlinge in Grau killen! :(
for (y=0;y<ysize;y++)
{ int iii;
  for (iii=ii=x=0;x<xsize;x++)
  { r=3 & (buf2[0]>>4);
    g=3 & (buf2[0]>>2);
    b=3 & buf2[0]; 
    i= ((b==r) && (b==g)) ? 1 : 0; // Graupixel oder Weiss?
    if ((i & iii & (ii^1))==1)     // Farblos umschliesst farbig?
      if ( ( buf2[-3] & ((3<<2)|(3<<4)) ) !=0)  // Rotling oder Gruenling?
        if ((buf2[0] & buf2[-6]) != 63) // nicht zwischen Weiss?
          buf2[-3] = (buf2[-6] != 63) ? buf2[-6] : buf2[0]; // Farbe raus!
    buf2+=3;
    iii=ii; ii=i; // History
  };
};

#ifdef DEBUG
  buf2 = buf + ((ysize>10) ? (30 * xsize) : 0);
  buf2[0] = 3<<4; /* R */ buf2[6] = 3<<2; /* G */ buf2[12] = 3; /* B */ 
#endif

return 0;
};

