#include "jpg2pcx.h"

int main(int argc,char * argv[])
{
int result,xsize,ysize,n;
unsigned char * tga;
int * tga_32;

int fd,fsize;
struct stat status;
char ziel[PATH_MAX];
char quelle[PATH_MAX];

if ((argc!=2) || (!argv[0]) || (!argv[1]) || 
    (strlen(argv[0])>=100)   || (strlen(argv[1])>=100))
 { fprintf(stderr,"%s: argv[1] nennt ein Bild welches PCX werden soll\n",
                  argv[0]); 
   return 1; 
 };

srandom(time(NULL)); // seed
for (n=0;n<(random() & 15)+10;n++) (void)random();

snprintf(quelle,PATH_MAX-1,"%s",argv[1]);
n=random();
snprintf(ziel,PATH_MAX-1,"TGA:/tmp/jpg2pcx-%x.tga",n);
result = rufe_convert(quelle,ziel,"+compress","-verbose",NULL);
// +compress means do NOT compress
if (result) { fprintf(stderr,"convert to TGA tempfile failed\n"); return 1; };

snprintf(ziel,PATH_MAX-1,"/tmp/jpg2pcx-%x.tga",n);
if (stat(ziel,&status)) 
   { fprintf(stderr,"could not stat TGA tempfile\n"); return 1; };
fsize = status.st_size;
if (!S_ISREG(status.st_mode)) 
   { fprintf(stderr,"TGA image tempfile is not a regular file\n"); return 1; };

fd = open(ziel,O_RDONLY|0400000); // 04... ist O_NOFOLLOW
unlink(ziel); // sofort - bleibt trotzdem erhalten bis fd zu ist!
if (!fd) { fprintf(stderr,"could not open TGA image\n"); return 1; };

tga = malloc(fsize); tga_32 = (int *)tga;
if (!tga) { fprintf(stderr,"could not malloc ram for TGA image\n"); return 1; };
if ((n=read(fd,tga,fsize))<fsize) 
   { fprintf(stderr,"could only read %d of %d bytes TGA image\n",n,fsize);
     return 1; // reason could be just intr, so cont for the rest would be ok
   };
close(fd);

#ifndef SPARC
  if (((tga_32[0] & 0x0ffffff00) !=0x00020000) || 
      (tga_32[1] != 0) || (tga_32[2] != 0) ||
      (tga_32[3] & 0x0f000f000) /* limit to 4095*4095 (48 MBy!) */ ||
      ((tga_32[4] & 0x0ffff) != 24)) /* must be 24bit format */
   { printf("supposed TGA is a strange type of file - abort\n"); return 1; };
  xsize = tga_32[3] & 0x0ffff; ysize = tga_32[3] >> 16;
#else
  xsize = tga[13]; xsize <<= 8; xsize += tga[12];
  ysize = tga[15]; ysize <<= 8; ysize += tga[14];
 // restliche Tests bei Sparc weggelassen...
#endif

if ( (xsize*ysize*3)>(fsize-(18+tga[0])) )
 { printf("unknown header (size %d, filesize %d, image %dx%d) in TGA\n",
          18+tga[0],fsize,xsize,ysize);
   return 1; };

if (!result) result = farbreduktion(tga+18+tga[0],xsize,ysize);
if (result) fprintf(stderr,"Error %d in color reduction\n",result);

snprintf(ziel,PATH_MAX-1,"%s.pcx",argv[1]);
// besser waere, eine Endung zu suchen und falls vorhanden zu ersetzen!

if (!result) result = pcxwrite(ziel,tga+18+tga[0],xsize,ysize);
if (result) fprintf(stderr,"Error %d in PCX write\n",result);

return result;
};
